{$include: 'types.int'}
{$include: 'globals.int'}

program BDAY (input,output,period);

{Birthday finder for DLX

 To build: pl /c bday.pas
           link bday+globals,,,/NOD/EXEPACK libpasa;
}

{DLX Bulletin Board System V7.0

 FREEWARE NOTICE

 DLX V7.0 is placed in the public domain by its author, Richard Gillmann.
 Anyone who wishes to may run the program, copy it, or modify it for
 any purpose, including commercial gain.}


USES types,globals;

{***Interface to MS Pascal library***}
procedure date(var s : string); EXTERN;

{***Special for calling file initialize module***}
procedure globals; EXTERN;

var
  period : integer;
  five : lstring(5);
  str : lstring(80);
  i,j : integer;
  month_now,day_now : integer;
  month,day : integer;
  got1 : boolean;

function getnum(const s : lstring; first,last : integer) : integer;
var
  total : integer;
  k : integer;
begin
  total:=0;
  for k:=first to last do begin
    if s[k]<'0' or else s[k]>'9' then break;
    total:=10*total + ord(s[k]) - ord('0');
  end;
  getnum := total;
end;

begin
  globals;
  assign(f_members,'MEMBERS');
  reset(f_members);
  str.len:=8;
  date(str);
  month_now:=getnum(str,1,2);
  day_now:=getnum(str,4,5);
  got1:=false;
  
  writeln;
  if period=12
    then writeln('Birthdays this month:')
    else writeln('Birthdays today:');

  while not eof(f_members) do begin
    readln(f_members,member_internal_buffer);
    movel(adr member_internal_buffer,adr member_buffer,member_length);
    if member_buffer.active[1] = 'T' and then
{the 5 characters starting at q'are 3, answer one are the birthday}
       member_buffer.mult_answer[3][1] <> ' ' then begin
      movel(adr member_buffer.mult_answer[3][1], adr five[1],5);
      five.len:=5;
      j:=6;
      for i:=1 to 5 do
        if not (five[i] in ['0'..'9']) then
          [j:=i; break];
      if j in [2..4]
        then [month:=getnum(five,1,j-1); day:=getnum(five,j+1,5)]
        else cycle;
      movel(adr member_buffer.name,adr str[1],name_width);
      movel(adr member_buffer.userid,adr str[name_width+2],5);
      str[name_width+1]:=' ';
      str.len:=name_width+6;
      for i:=ord(str.len) downto 2 do {remove multiple blanks}
        if str[i]=' ' and then str[i-1]=' ' then
          delete(str,i,1);
      for i:=1 to ord(str.len) do {filter amps to avoid problems in news file}
        if str[i]='&' then
	  str[i] := 'n';
      if period=12 then
        [if month=month_now then
           [writeln(str:26,' ',month:1,'/',day:1); got1:=true]]
      else if month=month_now and then day=day_now then
             [writeln(str:26,' ',month:1,'/',day:1); got1:=true];
    end;
  end;
  close(f_members);
  if not got1 then
    if period=12
      then writeln('    No birthdays this month')
      else writeln('    No birthdays today');
end.
