	Title	Extndh Extends maximum number of file handles
	page	55,131
tblsiz	equ	35		;Number of files to allow
; 6/14/88 Modified to use int 67h.  R.A.G.
;
; IMPORTANT NOTE!!!!  There is a bug in the DOS 3.3 int 67h call.
;  If you ask for an even number of handles, it allocates an
;  extra 64K of memory.  See PC Tech J. August 1987.
;  Note that pascal can allocate tblsiz-3 disk files.
;
;	This program extends the number of file handles from 20
;	to as many as you might want. Extndh was written from
;	information on Pages 107-108 of Dr. Dobb's Journal, May 1986
;	Thanks to Jeff Jacobsen <SL421%USU.BITNET@WISCVM.WISC.EDU>
;	for pointing this out in V5 #49 of INFO-IBMPC.
;
;	Extndh can be called by MS Pascal.
;
;	Note extndh uses undocumented fields in the program segment
;	prefix. It also uses the undocumented call 51H when running
;	under DOS 2.x. As DOS 2 isn't changing this shouldn't matter.
;	If Microsoft chooses to document these fields in later versions
;	of DOS this program should continue to work.
;	This program also writes in the code segment. This could
;	be a problem in protected versions of DOS. This makes the code
;	non-reentrant. That was intentional. In general this is dangerous
;	code and could make hash out of your file system. Don't use
;	this code to run nuclear reactors or heart lung machines or
;	much of anything else that could be dangerous!
;
;	You must set the FILES= parameter in CONFIG.SYS to some appropriate
;	value.
;
;	If successful this function returns the new max number of file
;	handles. If not successful it returns -1.
;
; (original code by W.A.B.)
psp	segment at 0
	org	32h		;Skip all that stuff
maxhdl	dw	?		;Maximum handles
hdltbl	dd	?		;Pointer to Handle table
psp	ends

EXTNDH_CODE segment para public 'CODE' ;Pascal likes this segment for code
	assume	cs:EXTNDH_CODE,ds:psp,es:nothing
newtbl	db	tblsiz dup (0ffh)
	public	extndh
extndh	proc	far		;Pascal doesn't have silly _
	push	si		;C says save these
	push	di
	push	ds		;Save bp if we touch it!
	push	bp		;Who knows, we just might!
	mov	ah,30h
	int	21h		;Get DOS version number
	cmp	al,2
	jl	badxit		;Not supporting DOS1
	je	dos2
	cmp	al,3
	ja	dos33		;Assume int 67h available in DOS 4+ or OS/2
	cmp	ah,30
	jae	dos33		;Int 67h available in DOS 3.30
dos30:	mov	ax,6200h	;Documented DOS3 call to get psp
	int	21h
	jmp	short intok	;no error conditions
dos2:	mov	ax,5100h	;Undocumented DOS2 call but it isn't changing!
	int	21h
	jnc	intok
badxit:	mov	ax,-1
	jmp	short xit
dos33:	mov	ah,67h		;Set handle count
	mov	bx,tblsiz	;Number of handles desired
	or	bx,1		;Avoid bug
	int	21h		;Dos 3.3 function
	jc	badxit		;Jump if error
	mov	ax,tblsiz	;Return number allocated
	jmp	short xit	;done
intok:	mov	ds,bx		;Get PSP's segment pointer
	lds	si,hdltbl	;Make SI point to table
	mov	ax,cs		;New table is in cs segment
	mov	es,ax
	mov	cx,maxhdl	;How many entries in DOS Table
	cmp	cx,tblsiz	;If existing DOS table larger than what we
	jge	gdxit		;are asking for take larger table
	lea	di,cs:newtbl	;Point to new table
	rep	movsb		;Move table
	lea	si,cs:newtbl	;Point to new table
	mov	word ptr hdltbl,si ;Reset psp pointer
	mov	ax,cs		;Wish there was store equliv of lds
	mov	word ptr hdltbl+2,ax
	mov	cx,tblsiz	;Return size of table
	mov	maxhdl,cx	;Also store in psp
gdxit:	mov	ax,cx
xit:	pop	bp
	pop	ds
	pop	di
	pop	si
	ret
extndh	endp
EXTNDH_CODE ends
	end
